/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.62 Revision 1.84
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.62 2007/01/05 22:51:21 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.84 2008/01/16 04:01:14 robbat2 Exp $
4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off;
7 4
8# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 5# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
9# Maintainer: Luca Longinotti <chtekk@gentoo.org> 6# Maintainer: Luca Longinotti <chtekk@gentoo.org>
10 7
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too!
11# Note that MYSQL_VERSION_ID must be empty !!! 9# Note that MYSQL_VERSION_ID must be empty!
12 10
13ECLASS="mysql"
14INHERITED="$INHERITED $ECLASS"
15WANT_AUTOCONF="latest" 11WANT_AUTOCONF="latest"
16WANT_AUTOMAKE="latest" 12WANT_AUTOMAKE="latest"
13
17inherit eutils flag-o-matic gnuconfig autotools mysql_fx 14inherit eutils flag-o-matic gnuconfig autotools mysql_fx
18 15
19# Shorten the path because the socket path length must be shorter than 107 chars 16# Shorten the path because the socket path length must be shorter than 107 chars
20# and we will run a mysql server during test phase 17# and we will run a mysql server during test phase
21S="${WORKDIR}/mysql" 18S="${WORKDIR}/mysql"
22 19
23[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070105" 20[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070108"
24 21
25if [[ ${PR#r} -lt 60 ]] ; then 22if [[ ${PR#r} -lt 60 ]] ; then
26 IS_BITKEEPER=0 23 IS_BITKEEPER=0
27elif [[ ${PR#r} -lt 90 ]] ; then 24elif [[ ${PR#r} -lt 90 ]] ; then
28 IS_BITKEEPER=60 25 IS_BITKEEPER=60
33# MYSQL_VERSION_ID will be: 30# MYSQL_VERSION_ID will be:
34# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 31# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
35# This is an important part, because many of the choices the MySQL ebuild will do 32# This is an important part, because many of the choices the MySQL ebuild will do
36# depend on this variable. 33# depend on this variable.
37# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 34# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
35
38MYSQL_VERSION_ID="" 36MYSQL_VERSION_ID=""
39tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 37tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
40for vatom in 0 1 2 3 ; do 38for vatom in 0 1 2 3 ; do
41 # pad to length 2 39 # pad to length 2
42 tpv[${vatom}]="00${tpv[${vatom}]}" 40 tpv[${vatom}]="00${tpv[${vatom}]}"
49DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 47DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
50 userland_GNU? ( sys-process/procps ) 48 userland_GNU? ( sys-process/procps )
51 >=sys-apps/sed-4 49 >=sys-apps/sed-4
52 >=sys-apps/texinfo-4.7-r1 50 >=sys-apps/texinfo-4.7-r1
53 >=sys-libs/readline-4.1 51 >=sys-libs/readline-4.1
54 >=sys-libs/zlib-1.2.3 52 >=sys-libs/zlib-1.2.3"
55 "
56 53
57# having different flavours at the same time is not a good idea 54# Having different flavours at the same time is not a good idea
58for i in "" "-community" "-slotted" ; do 55for i in "" "-community" ; do
59 [[ "${i}" == ${PN#mysql} ]] || 56 [[ "${i}" == ${PN#mysql} ]] ||
60 DEPEND="${DEPEND} !dev-db/mysql${i}" 57 DEPEND="${DEPEND} !dev-db/mysql${i}"
61done 58done
62 59
63mysql_version_is_at_least "5.1" \ 60mysql_version_is_at_least "5.1" \
64|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 61|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
65 62
63mysql_version_is_at_least "5.1.12" \
64&& DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
65
66# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 66# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
67PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 67PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
68 68
69if mysql_version_is_at_least "5.1.12" ; then
70 DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
71fi
72
73# BitKeeper dependency, compile-time only 69# BitKeeper dependency, compile-time only
74[[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client" 70[[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
75 71
72# Work out the default SERVER_URI correctly
73if [ -z "${SERVER_URI}" ]; then
74 # The community build is on the mirrors
75 if [ "${PN}" == "mysql-community" ]; then
76 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz"
77 # The enterprise source is on the primary site only
76if [[ ${PN} == "mysql-slotted" ]] ; then 78 elif [ "${PN}" == "mysql" ]; then
77 DEPEND="${DEPEND} app-admin/eselect-mysql" 79 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz"
80 fi
78fi 81fi
79 82
80if [[ ${PN} == "mysql-slotted" ]] ; then
81 SLOT=""
82 tpv=( ${PV//[-._]/ } )
83 for vatom in 0 1 2 ; do
84 SLOT="${SLOT}${tpv[${vatom}]}_"
85 done
86 #finally SLOT=5_0_24
87 SLOT=${SLOT:0:${#SLOT}-1}
88else
89 SLOT="0"
90fi
91
92# Define correct SRC_URIs 83# Define correct SRC_URIs
93SRC_URI=" 84SRC_URI="${SERVER_URI}
94${SERVER_URI} 85 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
95http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 86 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
96"
97mysql_version_is_at_least "5.1.12" \ 87mysql_version_is_at_least "5.1.12" \
98&& [[ -n "${PBXT_VERSION}" ]] \ 88&& [[ -n "${PBXT_VERSION}" ]] \
99&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )" 89&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
100 90
101DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 91DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
102HOMEPAGE="http://www.mysql.com/" 92HOMEPAGE="http://www.mysql.com/"
103LICENSE="GPL-2" 93LICENSE="GPL-2"
94SLOT="0"
104IUSE="big-tables debug embedded minimal perl selinux ssl static" 95IUSE="big-tables debug embedded minimal perl selinux ssl static"
105RESTRICT="confcache"
106 96
107mysql_version_is_at_least "4.1" \ 97mysql_version_is_at_least "4.1" \
108&& IUSE="${IUSE} latin1" 98&& IUSE="${IUSE} latin1"
109 99
110mysql_version_is_at_least "4.1.3" \ 100mysql_version_is_at_least "4.1.3" \
124 114
125mysql_version_is_at_least "5.1.12" \ 115mysql_version_is_at_least "5.1.12" \
126&& IUSE="${IUSE} pbxt" 116&& IUSE="${IUSE} pbxt"
127 117
128RDEPEND="${DEPEND} 118RDEPEND="${DEPEND}
129sys-apps/mysql 119 !minimal? ( dev-db/mysql-init-scripts )
130selinux? ( sec-policy/selinux-mysql ) 120 selinux? ( sec-policy/selinux-mysql )"
131"
132 121
133EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 122EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
134 pkg_postinst pkg_config pkg_postrm 123 pkg_postinst pkg_config pkg_postrm
135 124
136# 125#
137# HELPER FUNCTIONS: 126# HELPER FUNCTIONS:
138# 127#
139 128
140bitkeeper_fetch() { 129bitkeeper_fetch() {
141
142 local reposuf 130 local reposuf
143 if [[ -z "${1}" ]] ; then 131 if [[ -z "${1}" ]] ; then
144 local tpv 132 local tpv
145 tpv=( ${PV//[-._]/ } ) 133 tpv=( ${PV//[-._]/ } )
146 reposuf="mysql-${tpv[0]}.${tpv[1]}" 134 reposuf="mysql-${tpv[0]}.${tpv[1]}"
147 else 135 else
148 reposuf="${1}" 136 reposuf="${1}"
149 fi 137 fi
150 einfo "using \"${reposuf}\" repository." 138 einfo "Using '${reposuf}' repository."
151 local repo_uri="bk://mysql.bkbits.net/${reposuf}" 139 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
152 ## -- ebk_store_dir: bitkeeper sources store directory 140 ## -- ebk_store_dir: bitkeeper sources store directory
153 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src" 141 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
154 ## -- ebk_fetch_cmd: bitkeeper fetch command 142 ## -- ebk_fetch_cmd: bitkeeper fetch command
155 # always fetch the latest revision, use -r<revision> if a specified revision is wanted 143 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
156 # hint: does not work 144 # hint: does not work
157 local ebk_fetch_cmd="sfioball" 145 local ebk_fetch_cmd="sfioball"
158 ## -- ebk_update_cmd: bitkeeper update command 146 ## -- ebk_update_cmd: bitkeeper update command
159 local ebk_update_cmd="update" 147 local ebk_update_cmd="update"
160 148
161 #addread "/etc/bitkeeper" 149 # addread "/etc/bitkeeper"
162 addwrite "${ebk_store_dir}" 150 addwrite "${ebk_store_dir}"
163 151
164 if [[ ! -d "${ebk_store_dir}" ]]; then 152 if [[ ! -d "${ebk_store_dir}" ]] ; then
165 debug-print "${FUNCNAME}: initial checkout. creating bitkeeper directory" 153 debug-print "${FUNCNAME}: initial checkout, creating bitkeeper directory ..."
166 mkdir -p "${ebk_store_dir}" || die "${EBK}: can't mkdir ${ebk_store_dir}." 154 mkdir -p "${ebk_store_dir}" || die "BK: couldn't mkdir ${ebk_store_dir}"
167 fi 155 fi
168 156
169 pushd "${ebk_store_dir}" || die "${EBK}: can't chdir to ${ebk_store_dir}" 157 pushd "${ebk_store_dir}" || die "BK: couldn't chdir to ${ebk_store_dir}"
170 158
171 local wc_path=${reposuf} 159 local wc_path=${reposuf}
172 160
173 if [[ ! -d "${wc_path}" ]]; then 161 if [[ ! -d "${wc_path}" ]] ; then
174 local options="-r+" 162 local options="-r+"
163
175 # first check out 164 # first checkout
176 einfo "bitkeeper check out start -->" 165 einfo "bitkeeper checkout start -->"
177 einfo " repository: ${repo_uri}" 166 einfo " repository: ${repo_uri}"
167
178 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \ 168 ${ebk_fetch_cmd} ${options} "${repo_uri}" "${wc_path}" \
179 || die "${EBK}: can't fetch from ${repo_uri}." 169 || die "BK: couldn't fetch from ${repo_uri}"
180 else 170 else
181 if [[ ! -d "${wc_path}/BK" ]]; then 171 if [[ ! -d "${wc_path}/BK" ]] ; then
182 popd 172 popd
183 die "Look like ${wc_path} is not a bitkeeper path." 173 die "Looks like ${wc_path} is not a bitkeeper path"
184 fi 174 fi
185 175
186 # update working copy 176 # update working copy
187 einfo "bitkeeper update start -->" 177 einfo "bitkeeper update start -->"
188 einfo " repository: ${repo_uri}" 178 einfo " repository: ${repo_uri}"
189 179
190 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \ 180 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
191 || die "BK: can't update from ${repo_uri} to ${wc_path}." 181 || die "BK: couldn't update from ${repo_uri} to ${wc_path}"
192 fi 182 fi
193 183
194 einfo " working copy: ${wc_path}" 184 einfo " working copy: ${wc_path}"
195 cd "${wc_path}" 185 cd "${wc_path}"
196 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: can't export to ${S}." 186 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: couldn't export to ${S}"
197 187
198 echo 188 echo
199 popd 189 popd
200
201} 190}
202 191
203mysql_disable_test() { 192mysql_disable_test() {
204 local testname="${1}" ; shift 193 local testname="${1}" ; shift
205 local reason="${@}" 194 local reason="${@}"
206 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 195 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
207 echo ${testname} : ${reason} >> "${mysql_disable_file}" 196 echo ${testname} : ${reason} >> "${mysql_disable_file}"
208 ewarn "test \"${testname}\" disabled because: \"${reason}\"" 197 ewarn "test '${testname}' disabled: '${reason}'"
209} 198}
210 199
211# void mysql_init_vars() 200# void mysql_init_vars()
212# 201#
213# Initialize global variables 202# Initialize global variables
214# 2005-11-19 <vivo@gentoo.org> 203# 2005-11-19 <vivo@gentoo.org>
215 204
216mysql_init_vars() { 205mysql_init_vars() {
217 if [[ ${SLOT} == "0" ]] ; then
218 MY_SUFFIX=""
219 else
220 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
221 fi
222 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"} 206 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
223 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"} 207 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
224 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"} 208 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
225 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"} 209 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
226 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"} 210 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
227 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"} 211 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
228 212
229 if [[ -z "${DATADIR}" ]] ; then 213 if [[ -z "${MY_DATADIR}" ]] ; then
230 DATADIR="" 214 MY_DATADIR=""
231 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 215 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
232 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null \ 216 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
233 | sed -ne '/datadir/s|^--datadir=||p' \ 217 | sed -ne '/datadir/s|^--datadir=||p' \
234 | tail -n1` 218 | tail -n1`
235 if [[ -z "${DATADIR}" ]] ; then 219 if [[ -z "${MY_DATADIR}" ]] ; then
236 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 220 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
237 | sed -e 's/.*=\s*//'` 221 | sed -e 's/.*=\s*//'`
238 fi 222 fi
239 fi 223 fi
240 if [[ -z "${DATADIR}" ]] ; then 224 if [[ -z "${MY_DATADIR}" ]] ; then
241 DATADIR="${MY_LOCALSTATEDIR}" 225 MY_DATADIR="${MY_LOCALSTATEDIR}"
242 einfo "Using default DATADIR" 226 einfo "Using default MY_DATADIR"
243 fi 227 fi
244 elog "MySQL DATADIR is ${DATADIR}" 228 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
245 229
246 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 230 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
247 if [[ -e "${DATADIR}" ]] ; then 231 if [[ -e "${MY_DATADIR}" ]] ; then
248 elog "Previous datadir found, it's YOUR job to change" 232 elog "Previous datadir found, it's YOUR job to change"
249 elog "ownership and take care of it" 233 elog "ownership and take care of it"
250 PREVIOUS_DATADIR="yes" 234 PREVIOUS_DATADIR="yes"
251 else 235 else
252 PREVIOUS_DATADIR="no" 236 PREVIOUS_DATADIR="no"
256 fi 240 fi
257 241
258 MY_SOURCEDIR=${SERVER_URI##*/} 242 MY_SOURCEDIR=${SERVER_URI##*/}
259 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 243 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
260 244
261 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR 245 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
262 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 246 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
263 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR 247 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
264} 248}
265 249
266configure_minimal() { 250configure_minimal() {
267 # These are things we exclude from a minimal build, please 251 # These are things we exclude from a minimal build, please
268 # note that the server actually does get built and installed, 252 # note that the server actually does get built and installed,
269 # but we then delete it before packaging. 253 # but we then delete it before packaging.
270 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 254 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
271 255
272 for i in ${minimal_exclude_list} ; do 256 for i in ${minimal_exclude_list} ; do
273 myconf="${myconf} --without-${i}" 257 myconf="${myconf} --without-${i}"
274 done 258 done
275 myconf="${myconf} --with-extra-charsets=none" 259 myconf="${myconf} --with-extra-charsets=none"
276 myconf="${myconf} --enable-local-infile" 260 myconf="${myconf} --enable-local-infile"
277 261
278 if useq "static" ; then 262 if use static ; then
279 myconf="${myconf} --with-client-ldflags=-all-static" 263 myconf="${myconf} --with-client-ldflags=-all-static"
280 myconf="${myconf} --disable-shared" 264 myconf="${myconf} --disable-shared --with-pic"
281 else 265 else
282 myconf="${myconf} --enable-shared --enable-static" 266 myconf="${myconf} --enable-shared --enable-static"
283 fi 267 fi
284 268
285 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 269 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
286 myconf="${myconf} --with-charset=utf8" 270 myconf="${myconf} --with-charset=utf8"
287 myconf="${myconf} --with-collation=utf8_general_ci" 271 myconf="${myconf} --with-collation=utf8_general_ci"
288 else 272 else
289 myconf="${myconf} --with-charset=latin1" 273 myconf="${myconf} --with-charset=latin1"
290 myconf="${myconf} --with-collation=latin1_swedish_ci" 274 myconf="${myconf} --with-collation=latin1_swedish_ci"
298 myconf="${myconf} --with-mysqld-user=mysql" 282 myconf="${myconf} --with-mysqld-user=mysql"
299 myconf="${myconf} --with-server" 283 myconf="${myconf} --with-server"
300 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock" 284 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
301 myconf="${myconf} --without-libwrap" 285 myconf="${myconf} --without-libwrap"
302 286
303 if useq "static" ; then 287 if use static ; then
304 myconf="${myconf} --with-mysqld-ldflags=-all-static" 288 myconf="${myconf} --with-mysqld-ldflags=-all-static"
305 myconf="${myconf} --with-client-ldflags=-all-static" 289 myconf="${myconf} --with-client-ldflags=-all-static"
306 myconf="${myconf} --disable-shared" 290 myconf="${myconf} --disable-shared --with-pic"
307 else 291 else
308 myconf="${myconf} --enable-shared --enable-static" 292 myconf="${myconf} --enable-shared --enable-static"
309 fi 293 fi
310 294
311 if useq "debug" ; then 295 if use debug ; then
312 myconf="${myconf} --with-debug=full" 296 myconf="${myconf} --with-debug=full"
313 else 297 else
314 myconf="${myconf} --without-debug" 298 myconf="${myconf} --without-debug"
315 mysql_version_is_at_least "4.1.3" \ 299 mysql_version_is_at_least "4.1.3" \
316 && useq "cluster" \ 300 && use cluster \
317 && myconf="${myconf} --without-ndb-debug" 301 && myconf="${myconf} --without-ndb-debug"
318 fi 302 fi
319 303
320 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then 304 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
321 myconf="${myconf} --with-charset=utf8" 305 myconf="${myconf} --with-charset=utf8"
322 myconf="${myconf} --with-collation=utf8_general_ci" 306 myconf="${myconf} --with-collation=utf8_general_ci"
323 else 307 else
324 myconf="${myconf} --with-charset=latin1" 308 myconf="${myconf} --with-charset=latin1"
325 myconf="${myconf} --with-collation=latin1_swedish_ci" 309 myconf="${myconf} --with-collation=latin1_swedish_ci"
326 fi 310 fi
327 311
328 if useq "embedded" ; then 312 if use embedded ; then
329 myconf="${myconf} --with-embedded-privilege-control" 313 myconf="${myconf} --with-embedded-privilege-control"
330 myconf="${myconf} --with-embedded-server" 314 myconf="${myconf} --with-embedded-server"
331 else 315 else
332 myconf="${myconf} --without-embedded-privilege-control" 316 myconf="${myconf} --without-embedded-privilege-control"
333 myconf="${myconf} --without-embedded-server" 317 myconf="${myconf} --without-embedded-server"
341 myconf="${myconf} --with-extra-tools" 325 myconf="${myconf} --with-extra-tools"
342 myconf="${myconf} --with-innodb" 326 myconf="${myconf} --with-innodb"
343 myconf="${myconf} --without-readline" 327 myconf="${myconf} --without-readline"
344 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 328 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
345 329
346 if useq "ssl" ; then
347 # --with-vio is not needed anymore, it's on by default and 330 # --with-vio is not needed anymore, it's on by default and
348 # has been removed from configure 331 # has been removed from configure
332 if use ssl ; then
349 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 333 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
350 fi 334 fi
351 335
352 if mysql_version_is_at_least "5.1.11" ; then 336 if mysql_version_is_at_least "5.1.11" ; then
353 myconf="${myconf} $(use_with ssl)" 337 myconf="${myconf} $(use_with ssl)"
354 else 338 else
355 myconf="${myconf} $(use_with ssl openssl)" 339 myconf="${myconf} $(use_with ssl openssl)"
356 fi 340 fi
357 341
342 if use berkdb ; then
358 # The following fix is due to a bug with bdb on SPARC's. See: 343 # The following fix is due to a bug with bdb on SPARC's. See:
359 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8 344 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
360 # It comes down to non-64-bit safety problems. 345 # It comes down to non-64-bit safety problems.
361 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then 346 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
362 elog "Berkeley DB support was disabled due to incompatible arch" 347 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
348 myconf="${myconf} --without-berkeley-db"
349 else
350 myconf="${myconf} --with-berkeley-db=./bdb"
351 fi
352 else
363 myconf="${myconf} --without-berkeley-db" 353 myconf="${myconf} --without-berkeley-db"
364 else
365 if useq "berkdb" ; then
366 myconf="${myconf} --with-berkeley-db=./bdb"
367 else
368 myconf="${myconf} --without-berkeley-db"
369 fi
370 fi 354 fi
371 355
372 if mysql_version_is_at_least "4.1.3" ; then 356 if mysql_version_is_at_least "4.1.3" ; then
373 myconf="${myconf} --with-geometry" 357 myconf="${myconf} --with-geometry"
374 myconf="${myconf} $(use_with cluster ndbcluster)" 358 myconf="${myconf} $(use_with cluster ndbcluster)"
375 fi 359 fi
376 360
377 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then 361 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
378 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 362 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
379 myconf="${myconf} --with-archive-storage-engine" 363 myconf="${myconf} --with-archive-storage-engine"
380 364
381 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 365 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
382 myconf="${myconf} --with-csv-storage-engine" 366 myconf="${myconf} --with-csv-storage-engine"
393 myconf="${myconf} --with-federated-storage-engine" 377 myconf="${myconf} --with-federated-storage-engine"
394 fi 378 fi
395 fi 379 fi
396 380
397 mysql_version_is_at_least "5.0.18" \ 381 mysql_version_is_at_least "5.0.18" \
398 && useq "max-idx-128" \ 382 && use max-idx-128 \
399 && myconf="${myconf} --with-max-indexes=128" 383 && myconf="${myconf} --with-max-indexes=128"
400} 384}
401 385
402configure_51() { 386configure_51() {
403 # TODO: !!!! readd --without-readline 387 # TODO: !!!! readd --without-readline
408 myconf="${myconf} --with-geometry" 392 myconf="${myconf} --with-geometry"
409 myconf="${myconf} --with-readline" 393 myconf="${myconf} --with-readline"
410 myconf="${myconf} --with-row-based-replication" 394 myconf="${myconf} --with-row-based-replication"
411 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 395 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
412 myconf="${myconf} --without-pstack" 396 myconf="${myconf} --without-pstack"
413 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128" 397 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
414 398
415 # 5.1 introduces a new way to manage storage engines (plugins) 399 # 5.1 introduces a new way to manage storage engines (plugins)
416 # like configuration=none 400 # like configuration=none
417 local plugins="csv,myisam,myisammrg,heap" 401 local plugins="csv,myisam,myisammrg,heap"
418 if useq "extraengine" ; then 402 if use extraengine ; then
419 # like configuration=max-no-ndb, archive and example removed in 5.1.11 403 # like configuration=max-no-ndb, archive and example removed in 5.1.11
420 plugins="${plugins},archive,blackhole,example,federated,partition" 404 plugins="${plugins},archive,blackhole,example,federated,partition"
421 405
422 elog "Before using the Federated storage engine, please be sure to read" 406 elog "Before using the Federated storage engine, please be sure to read"
423 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 407 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
424 fi 408 fi
425 409
426 if useq "innodb" ; then 410 if use innodb ; then
427 plugins="${plugins},innobase" 411 plugins="${plugins},innobase"
428 fi 412 fi
429 413
430 # like configuration=max-no-ndb 414 # like configuration=max-no-ndb
431 if useq "cluster" ; then 415 if use cluster ; then
432 plugins="${plugins},ndbcluster" 416 plugins="${plugins},ndbcluster"
433 myconf="${myconf} --with-ndb-binlog" 417 myconf="${myconf} --with-ndb-binlog"
434 fi 418 fi
435 419
436 if mysql_version_is_at_least "5.2" ; then 420 if mysql_version_is_at_least "5.2" ; then
446 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 430 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
447 431
448 einfo "Reconfiguring dir '${PWD}'" 432 einfo "Reconfiguring dir '${PWD}'"
449 AT_GNUCONF_UPDATE="yes" eautoreconf 433 AT_GNUCONF_UPDATE="yes" eautoreconf
450 434
451 local myconf 435 local myconf=""
452 myconf="${myconf} --with-mysql=${S}"
453 mkdir -p ${T}/lib
454 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}" 436 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}"
455 useq "debug" && myconf="${myconf} --with-debug=full" 437 use debug && myconf="${myconf} --with-debug=full"
456 # TODO is safe/needed to use econf here ? 438 # TODO: is it safe/needed to use econf here ?
457 ./configure ${myconf} || die "problem configuring pbxt storage engine" 439 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
458 # TODO is safe/needed to use emake here ? 440 # TODO: is it safe/needed to use emake here ?
459 make || die "problem making pbxt storage engine (${myconf})" 441 make || die "Problem making PBXT storage engine (${myconf})"
460 442
461 popd 443 popd
462 # TODO: modify test suite 444 # TODO: modify test suite for PBXT
463} 445}
464 446
465pbxt_src_install() { 447pbxt_src_install() {
466 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 448 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
467 make install || die "failed pbxt install" 449 make install || die "Failed to install PBXT"
468 popd 450 popd
469} 451}
470 452
471# 453#
472# EBUILD FUNCTIONS 454# EBUILD FUNCTIONS
473# 455#
474
475mysql_pkg_setup() { 456mysql_pkg_setup() {
476 enewgroup mysql 60 || die "problem adding 'mysql' group" 457 if hasq test ${FEATURES} ; then
477 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 458 if ! use minimal ; then
459 if ! hasq userpriv ${FEATURES} ; then
460 die "Testing with FEATURES=-userpriv is no longer supported by upstream"
461 fi
462 fi
463 fi
478 464
479 # Check for USE flag problems in pkg_setup 465 # Check for USE flag problems in pkg_setup
480 if useq "static" && useq "ssl" ; then 466 if use static && use ssl ; then
481 eerror "MySQL does not support being built statically with SSL support enabled!" 467 eerror "MySQL does not support being built statically with SSL support enabled!"
482 die "MySQL does not support being built statically with SSL support enabled!" 468 die "MySQL does not support being built statically with SSL support enabled!"
483 fi 469 fi
484 470
485 if ! mysql_version_is_at_least "5.0" \ 471 if ! mysql_version_is_at_least "5.0" \
486 && useq "raid" \ 472 && use raid \
487 && useq "static" ; then 473 && use static ; then
488 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 474 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
489 eerror "with RAID support enabled." 475 eerror "with RAID support enabled."
490 die "USE flags 'raid' and 'static' conflict!" 476 die "USE flags 'raid' and 'static' conflict!"
491 fi 477 fi
492 478
493 if mysql_version_is_at_least "4.1.3" \ 479 if mysql_version_is_at_least "4.1.3" \
494 && ( useq "cluster" || useq "extraengine" ) \ 480 && ( use cluster || use extraengine ) \
495 && useq "minimal" ; then 481 && use minimal ; then
496 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 482 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
497 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 483 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
498 fi 484 fi
485
486 # This should come after all of the die statements
487 enewgroup mysql 60 || die "problem adding 'mysql' group"
488 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
499 489
500 mysql_check_version_range "4.0 to 5.0.99.99" \ 490 mysql_check_version_range "4.0 to 5.0.99.99" \
501 && useq "berkdb" \ 491 && use berkdb \
502 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 492 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
503} 493}
504 494
505mysql_src_unpack() { 495mysql_src_unpack() {
506 # Initialize the proper variables first 496 # Initialize the proper variables first
508 498
509 unpack ${A} 499 unpack ${A}
510 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then 500 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then
511 if mysql_check_version_range "5.1 to 5.1.99" ; then 501 if mysql_check_version_range "5.1 to 5.1.99" ; then
512 bitkeeper_fetch "mysql-5.1-ndb" 502 bitkeeper_fetch "mysql-5.1-ndb"
513 elif mysql_check_version_range "5.2.0 to 5.2.99" ; then 503 elif mysql_check_version_range "5.2 to 5.2.99" ; then
514 bitkeeper_fetch "mysql-5.2-falcon" 504 bitkeeper_fetch "mysql-5.2-falcon"
515 else 505 else
516 bitkeeper_fetch 506 bitkeeper_fetch
517 fi 507 fi
518 cd "${S}" 508 cd "${S}"
519 einfo "running upstream autorun on bk sources" 509 einfo "Running upstream autorun over BK sources ..."
520 BUILD/autorun.sh 510 BUILD/autorun.sh
521 else 511 else
522 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}" 512 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
523 cd "${S}" 513 cd "${S}"
524 fi 514 fi
525 515
526 # Apply the patches for this MySQL version 516 # Apply the patches for this MySQL version
527 EPATCH_SUFFIX="patch" 517 EPATCH_SUFFIX="patch"
528 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory" 518 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
529 mysql_mv_patches 519 mysql_mv_patches
530 epatch || die "failed to apply all patches" 520 epatch
531 521
532 # Additional checks, remove bundled zlib 522 # Additional checks, remove bundled zlib
533 rm -f "${S}/zlib/"*.[ch] 523 rm -f "${S}/zlib/"*.[ch]
534 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 524 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
535 rm -f "scripts/mysqlbug" 525 rm -f "scripts/mysqlbug"
550 540
551 local rebuilddirlist d 541 local rebuilddirlist d
552 542
553 if mysql_version_is_at_least "5.1.12" ; then 543 if mysql_version_is_at_least "5.1.12" ; then
554 rebuilddirlist="." 544 rebuilddirlist="."
555 # TODO IMPO! Check this with a cmake expert 545 # TODO: check this with a cmake expert
556 useq "innodb" \ 546 use innodb \
557 && cmake \ 547 && cmake \
558 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \ 548 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
559 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \ 549 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
560 "storage/innobase" 550 "storage/innobase"
561 else 551 else
562 rebuilddirlist=". innobase" 552 rebuilddirlist=". innobase"
563 fi 553 fi
564 554
568 AT_GNUCONF_UPDATE="yes" eautoreconf 558 AT_GNUCONF_UPDATE="yes" eautoreconf
569 popd &>/dev/null 559 popd &>/dev/null
570 done 560 done
571 561
572 if mysql_check_version_range "4.1 to 5.0.99.99" \ 562 if mysql_check_version_range "4.1 to 5.0.99.99" \
573 && useq "berkdb" ; then 563 && use berkdb ; then
574 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 564 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
565 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
566 || die "Could not copy libtool.m4 to bdb/dist/"
575 pushd "bdb/dist" \ 567 pushd "bdb/dist" &>/dev/null
576 && sh s_all \ 568 sh s_all \
577 || die "Failed bdb reconfigure" \ 569 || die "Failed bdb reconfigure"
578 &>/dev/null
579 popd &>/dev/null 570 popd &>/dev/null
580 fi 571 fi
581} 572}
582 573
583mysql_src_compile() { 574mysql_src_compile() {
585 mysql_init_vars 576 mysql_init_vars
586 577
587 # $myconf is modified by the configure_* functions 578 # $myconf is modified by the configure_* functions
588 local myconf="" 579 local myconf=""
589 580
590 if useq "minimal" ; then 581 if use minimal ; then
591 configure_minimal 582 configure_minimal
592 else 583 else
593 configure_common 584 configure_common
594 if mysql_version_is_at_least "5.1.10" ; then 585 if mysql_version_is_at_least "5.1.10" ; then
595 configure_51 586 configure_51
609 mysql_version_is_at_least "5.0" \ 600 mysql_version_is_at_least "5.0" \
610 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 601 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
611 export CXXFLAGS 602 export CXXFLAGS
612 603
613 econf \ 604 econf \
614 --program-suffix="${MY_SUFFIX}" \
615 --libexecdir="/usr/sbin" \ 605 --libexecdir="/usr/sbin" \
616 --sysconfdir="${MY_SYSCONFDIR}" \ 606 --sysconfdir="${MY_SYSCONFDIR}" \
617 --localstatedir="${MY_LOCALSTATEDIR}" \ 607 --localstatedir="${MY_LOCALSTATEDIR}" \
618 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 608 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
619 --libdir="${MY_LIBDIR}" \ 609 --libdir="${MY_LIBDIR}" \
630 | xargs -0 -n100 sed -i \ 620 | xargs -0 -n100 sed -i \
631 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 621 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
632 622
633 emake || die "emake failed" 623 emake || die "emake failed"
634 624
635 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile 625 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile
636} 626}
637 627
638mysql_src_install() { 628mysql_src_install() {
639 # Make sure the vars are correctly initialized 629 # Make sure the vars are correctly initialized
640 mysql_init_vars 630 mysql_init_vars
641 631
642 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die 632 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed"
643 633
644 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install 634 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install
645 635
646 insinto "${MY_INCLUDEDIR}" 636 insinto "${MY_INCLUDEDIR}"
647 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 637 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
648 638
649 # Convenience links 639 # Convenience links
650 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}" 640 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
651 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}" 641 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
652 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}" 642 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
653 643
654 # Various junk (my-*.cnf moved elsewhere) 644 # Various junk (my-*.cnf moved elsewhere)
655 rm -Rf "${D}/usr/share/info" 645 rm -Rf "${D}/usr/share/info"
656 for removeme in "mysql-log-rotate" mysql.server* \ 646 for removeme in "mysql-log-rotate" mysql.server* \
657 binary-configure* my-*.cnf mi_test_all* 647 binary-configure* my-*.cnf mi_test_all*
658 do 648 do
659 rm -f "${D}"/usr/share/mysql/${removeme} 649 rm -f "${D}"/usr/share/mysql/${removeme}
660 done 650 done
661 651
662 # TODO change at Makefile-am level
663 if [[ ${PN} == "mysql-slotted" ]] ; then
664 for moveme in "mysql_fix_privilege_tables.sql" \
665 "fill_help_tables.sql" "ndb-config-2-node.ini"
666 do
667 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
668 done
669 fi
670
671 # clean up stuff for a minimal build 652 # Clean up stuff for a minimal build
672 if useq "minimal" ; then 653 if use minimal ; then
673 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 654 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
674 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 655 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
675 rm -f "${D}/usr/sbin/mysqld" 656 rm -f "${D}/usr/sbin/mysqld"
676 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 657 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
677 fi 658 fi
678 659
679 if [[ ${PN} == "mysql-slotted" ]] ; then
680 local notcatched=$(ls "${D}/usr/share/mysql"/*)
681 if [[ -n "${notcatched}" ]] ; then
682 ewarn "QA notice"
683 ewarn "${notcatched} files in /usr/share/mysql"
684 ewarn "bug mysql-herd to manage them"
685 fi
686 rm -Rf "${D}/usr/share/mysql"
687 fi
688
689 # Configuration stuff 660 # Configuration stuff
690 if mysql_version_is_at_least "4.1" ; then 661 if mysql_version_is_at_least "4.1" ; then
691 mysql_mycnf_version="4.1" 662 mysql_mycnf_version="4.1"
692 else 663 else
693 mysql_mycnf_version="4.0" 664 mysql_mycnf_version="4.0"
694 fi 665 fi
695 insinto "${MY_SYSCONFDIR}" 666 insinto "${MY_SYSCONFDIR}"
696 doins scripts/mysqlaccess.conf 667 doins scripts/mysqlaccess.conf
697 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
698 -e "s!@DATADIR@!${DATADIR}!g" \ 668 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
699 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 669 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
700 > "${TMPDIR}/my.cnf.ok" 670 > "${TMPDIR}/my.cnf.ok"
701 if mysql_version_is_at_least "4.1" && useq "latin1" ; then 671 if mysql_version_is_at_least "4.1" && use latin1 ; then
702 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 672 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
703 fi 673 fi
704 newins "${TMPDIR}/my.cnf.ok" my.cnf 674 newins "${TMPDIR}/my.cnf.ok" my.cnf
705 675
706 # Minimal builds don't have the MySQL server 676 # Minimal builds don't have the MySQL server
707 if ! useq "minimal" ; then 677 if ! use minimal ; then
708 # Empty directories ... 678 # Empty directories ...
709 diropts "-m0750" 679 diropts "-m0750"
710 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 680 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
711 dodir "${DATADIR}" 681 dodir "${MY_DATADIR}"
712 keepdir "${DATADIR}" 682 keepdir "${MY_DATADIR}"
713 chown -R mysql:mysql "${D}/${DATADIR}" 683 chown -R mysql:mysql "${D}/${MY_DATADIR}"
714 fi 684 fi
715 685
716 diropts "-m0755" 686 diropts "-m0755"
717 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do 687 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do
718 dodir "${folder}" 688 dodir "${folder}"
721 done 691 done
722 fi 692 fi
723 693
724 # Docs 694 # Docs
725 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 695 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
696 doinfo ${S}/Docs/mysql.info
726 697
727 # Minimal builds don't have the MySQL server 698 # Minimal builds don't have the MySQL server
728 if ! useq "minimal" ; then 699 if ! use minimal ; then
729 docinto "support-files" 700 docinto "support-files"
730 for script in \ 701 for script in \
731 support-files/my-*.cnf \ 702 support-files/my-*.cnf \
732 support-files/magic \ 703 support-files/magic \
733 support-files/ndb-config-2-node.ini 704 support-files/ndb-config-2-node.ini
737 708
738 docinto "scripts" 709 docinto "scripts"
739 for script in scripts/mysql* ; do 710 for script in scripts/mysql* ; do
740 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 711 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
741 done 712 done
742 fi
743 713
744 if [[ ${PN} == "mysql-slotted" ]] ; then
745 # MOVED HERE DUE TO BUG #121445
746 # create a list of files, to be used
747 # by external utilities
748 mkdir -p "${D}/var/lib/eselect/mysql/"
749 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
750 pushd "${D}/" &>/dev/null
751 find usr/bin/ usr/sbin/ \
752 -type f -name "*${MY_SUFFIX}*" \
753 -and -not -name "mysql_config${MY_SUFFIX}" \
754 > "${filelist}"
755 find usr/share/man \
756 -type f -name "*${MY_SUFFIX}*" \
757 | sed -e 's/$/.gz/' \
758 >> "${filelist}"
759 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
760 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
761 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
762 popd &>/dev/null
763 fi 714 fi
764 715
765 mysql_lib_symlinks "${D}" 716 mysql_lib_symlinks "${D}"
766} 717}
767 718
773mysql_pkg_postinst() { 724mysql_pkg_postinst() {
774 # Make sure the vars are correctly initialized 725 # Make sure the vars are correctly initialized
775 mysql_init_vars 726 mysql_init_vars
776 727
777 # Check FEATURES="collision-protect" before removing this 728 # Check FEATURES="collision-protect" before removing this
778 [[ -d "${ROOT}/var/log/mysql" ]] \
779 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}" 729 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
780 730
781 # Secure the logfiles 731 # Secure the logfiles
782 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err} 732 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
783 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql* 733 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
784 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql* 734 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
785 735
786 # Minimal builds don't have the MySQL server 736 # Minimal builds don't have the MySQL server
787 if ! useq "minimal" ; then 737 if ! use minimal ; then
788 docinto "support-files" 738 docinto "support-files"
789 for script in \ 739 for script in \
790 support-files/my-*.cnf \ 740 support-files/my-*.cnf \
791 support-files/magic \ 741 support-files/magic \
792 support-files/ndb-config-2-node.ini 742 support-files/ndb-config-2-node.ini
796 746
797 docinto "scripts" 747 docinto "scripts"
798 for script in scripts/mysql* ; do 748 for script in scripts/mysql* ; do
799 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 749 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
800 done 750 done
801 fi
802 751
803 einfo "you may want to read slotting upgrade documents in the overlay" 752 einfo
804 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then 753 elog "You might want to run:"
805 # TODO tell it better ;-) 754 elog "\"emerge --config =${CATEGORY}/${PF}\""
755 elog "if this is a new install."
756 einfo
757 fi
758
759 if mysql_version_is_at_least "5.1.12" && use pbxt ; then
760 # TODO: explain it better
806 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 761 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
807 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 762 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
808 einfo "if, after that you cannot start the mysql server" 763 elog "if, after that, you cannot start the MySQL server,"
809 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 764 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
810 einfo "use the mysql upgrade script to restore the table" 765 elog "use the MySQL upgrade script to restore the table"
811 einfo " or " 766 elog "or execute the following SQL command:"
812 einfo "CREATE TABLE IF NOT EXISTS plugin (" 767 elog " CREATE TABLE IF NOT EXISTS plugin ("
813 einfo " name char(64) binary DEFAULT '' NOT NULL," 768 elog " name char(64) binary DEFAULT '' NOT NULL,"
814 einfo " dl char(128) DEFAULT '' NOT NULL," 769 elog " dl char(128) DEFAULT '' NOT NULL,"
815 einfo " PRIMARY KEY (name)" 770 elog " PRIMARY KEY (name)"
816 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;" 771 elog " ) CHARACTER SET utf8 COLLATE utf8_bin;"
817 fi 772 fi
773
818 mysql_check_version_range "4.0 to 5.0.99.99" \ 774 mysql_check_version_range "4.0 to 5.0.99.99" \
819 && useq "berkdb" \ 775 && use berkdb \
820 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 776 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
821} 777}
822 778
823mysql_pkg_config() { 779mysql_pkg_config() {
824 # Make sure the vars are correctly initialized 780 # Make sure the vars are correctly initialized
825 mysql_init_vars 781 mysql_init_vars
826 782
827 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 783 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
828 784
829 if built_with_use ${CATEGORY}/${PN} minimal ; then 785 if built_with_use ${CATEGORY}/${PN} minimal ; then
830 die "Minimal builds do NOT include the MySQL server" 786 die "Minimal builds do NOT include the MySQL server"
831 fi 787 fi
832 788
833 local pwd1="a" 789 local pwd1="a"
834 local pwd2="b" 790 local pwd2="b"
835 local maxtry=5 791 local maxtry=5
836 792
837 if [[ -d "${ROOT}/${DATADIR}/mysql" ]] ; then 793 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
838 ewarn "You have already a MySQL database in place." 794 ewarn "You have already a MySQL database in place."
839 ewarn "(${ROOT}/${DATADIR}/*)" 795 ewarn "(${ROOT}/${MY_DATADIR}/*)"
840 ewarn "Please rename or delete it if you wish to replace it." 796 ewarn "Please rename or delete it if you wish to replace it."
841 die "MySQL database already exists!" 797 die "MySQL database already exists!"
842 fi 798 fi
843 799
844 einfo "Creating the mysql database and setting proper" 800 einfo "Creating the mysql database and setting proper"
865 help_tables="${TMPDIR}/fill_help_tables.sql" 821 help_tables="${TMPDIR}/fill_help_tables.sql"
866 822
867 pushd "${TMPDIR}" &>/dev/null 823 pushd "${TMPDIR}" &>/dev/null
868 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR" 824 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR"
869 popd &>/dev/null 825 popd &>/dev/null
870 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 826 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
871 || die "MySQL databases not installed" 827 || die "MySQL databases not installed"
872 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 828 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2> /dev/null
873 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 829 chmod 0750 "${ROOT}/${MY_DATADIR}" 2> /dev/null
874 830
875 if mysql_version_is_at_least "4.1.3" ; then 831 if mysql_version_is_at_least "4.1.3" ; then
876 options="--skip-ndbcluster" 832 options="--skip-ndbcluster"
877 833
878 # Filling timezones, see 834 # Filling timezones, see
889 local mysqld="${ROOT}/usr/sbin/mysqld \ 845 local mysqld="${ROOT}/usr/sbin/mysqld \
890 ${options} \ 846 ${options} \
891 --user=mysql \ 847 --user=mysql \
892 --skip-grant-tables \ 848 --skip-grant-tables \
893 --basedir=${ROOT}/usr \ 849 --basedir=${ROOT}/usr \
894 --datadir=${ROOT}/${DATADIR} \ 850 --datadir=${ROOT}/${MY_DATADIR} \
895 --skip-innodb \ 851 --skip-innodb \
896 --skip-bdb \ 852 --skip-bdb \
897 --skip-networking \ 853 --skip-networking \
898 --max_allowed_packet=8M \ 854 --max_allowed_packet=8M \
899 --net_buffer_length=16K \ 855 --net_buffer_length=16K \
929 wait %1 885 wait %1
930 einfo "Done" 886 einfo "Done"
931} 887}
932 888
933mysql_pkg_postrm() { 889mysql_pkg_postrm() {
934 if [[ ${PN} == "mysql-slotted" ]] ; then
935 mysql_lib_symlinks 890 : # mysql_lib_symlinks "${D}"
936 mysql_clients_link_to_best_version
937 fi
938} 891}

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.84

  ViewVC Help
Powered by ViewVC 1.1.20